DEVICE_ATTACH(9)

NAME
DEVICE_ATTACH - attach a device

SYNOPSIS
#include <sys/param.h>
#include <sys/bus.h>
int
DEVICE_ATTACH(device_t dev);

DESCRIPTION
Attach a device to the system after the DEVICE_PROBE() method has been called and has indicated that the device exists. The DEVICE_ATTACH() method should initialize the hardware and allocate other system resources (such as devfs(4) entries).

Devices which implement buses should use this method to probe for the existence of devices attached to the bus and add them as children. If this is combined with the use of bus_attach_children(9) the child devices will be automatically probed and attached.

RETURN VALUES
Zero is returned on success, otherwise an appropriate error is returned.

SEE ALSO
devfs(4), bus_attach_children(9), device(9), DEVICE_DETACH(9), DEVICE_IDENTIFY(9), DEVICE_PROBE(9), DEVICE_SHUTDOWN(9)

AUTHORS
This manual page was written by Doug Rabson <dfr@FreeBSD.org>.